//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Kanayomi
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            KknFuriganaCheck KknFC = new KknFuriganaCheck();
            KknFC.KuSetting(iShift);
            label1.Text = KknFC.Kanjihiragana.KamiPhrase;
            label2.Text = KknFC.Kanjihiragana.NakaPhrase;
            label3.Text = KknFC.Kanjihiragana.ShimoPhrase;

            textBox1.Text = ""; textBox2.Text = ""; textBox3.Text = "";
            textBox4.Text = ""; textBox5.Text = ""; textBox6.Text = "";

            KuE q;
            q = KknFC.KamiNakaShimoE(KknFC.Kanjihiragana.PhraseE);
            label7.Text = q.kamiE;
            label8.Text = q.nakaE;
            label9.Text = q.shimoE;
            label10.Text = "...Translated by Donald Keene";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            KknFuriganaCheck KknFC = new KknFuriganaCheck();
            KknFC.KuSetting(iShift);

            KknFC.KknWorking.KknKami = textBox1.Text;
            KknFC.KknWorking.KknNaka = textBox2.Text;
            KknFC.KknWorking.KknShimo = textBox3.Text;

            textBox4.Text = KknFC.KknMyFurigana();
            textBox5.Text = KknFC.KknCorrectFurigana();
            textBox6.Text = KknFC.Score().ToString();

            //(^_^)  (~_~)  ('_') (*_* ) (@_@) (>_<) (`_`)  
            if (KknFC.Score() == 100) textBox6.Text = "^_^";
            if (KknFC.Score() == 67) textBox6.Text = "' _ '";
            if (KknFC.Score() == 66) textBox6.Text = "' _ '";
            if (KknFC.Score() == 34) textBox6.Text = "~_~";
            if (KknFC.Score() == 33) textBox6.Text = "~_~";
            if (KknFC.Score() == 0) textBox6.Text = "@_@";
            //(^_^)  (~_~)  ('_') (*_* ) (@_@) (>_<) (`_`)  
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ++iShift;
            if (iShift > 10) iShift = 1;

            KknFuriganaCheck KknFC = new KknFuriganaCheck();
            KknFC.KuSetting(iShift);
            label1.Text = KknFC.Kanjihiragana.KamiPhrase;
            label2.Text = KknFC.Kanjihiragana.NakaPhrase;
            label3.Text = KknFC.Kanjihiragana.ShimoPhrase;

            textBox1.Text = ""; textBox2.Text = ""; textBox3.Text = "";
            textBox4.Text = ""; textBox5.Text = ""; textBox6.Text = "";

            KuE q;
            q = KknFC.KamiNakaShimoE(KknFC.Kanjihiragana.PhraseE);
            label7.Text = q.kamiE;
            label8.Text = q.nakaE;
            label9.Text = q.shimoE;
            label10.Text = " ...Translated by Donald Keene";

            textBox1.Focus();
        }

        int iShift = 1;

    }
}