//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;

namespace Kanayomi
{
	/// <summary>
	/// KknFuriganaCheck ̊Tv̐łB
	/// </summary>
	/// 


	public class KknFuriganaCheck
	{


		public KknFuriganaCheck()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

 		// 21
		Ku Natsukusaya = new Ku("đ","ǂ","̐","icNT","cmhK","mAg",
        "The summer grasses-/Of brave soldiers' dreams/The aftermath.");

        //10
		Ku Taichimai = new Ku("cꖇ","Aė","", "^C`}C","EGe^`T","iMJi",
        "Label7/Label8/Label9");

		//11
		Ku Unohanawo = new Ku("K̉Ԃ","Ɋւ","", "Emni","JUVjZLm","nMJi",
        "Label7/Label8/Label9");

		//14
		Ku Sanaetoru = new Ku("cƂ","Ƃ","̂Ԑ","TiGg","egJV","VmuY",
        "Label7/Label8/Label9");

		//27
		Ku Mayuhakiwo = new Ku("܂͂","݂ɂ","g̉","}nL","IJQjVe","xjmni",
        "Label7/Label8/Label9");

		//38
		Ku Kisakataya = new Ku("ۊ","Jɐ{","˂Ԃ̉","LTJ^","AjZCVK","lumni",
        "Label7/Label8/Label9");

		//46
		Ku Wasenokaya = new Ku("̍","E","LC","ZmJ","PC~Mn","A\E~",
        "Label7/Label8/Label9");

		//58
		Ku Monokakite = new Ku("","","]g","mJLe","AtMqLTN","iSJi",
        "Label7/Label8/Label9");

		//56
		Ku Yomosugara = new Ku("I","H","̎R","XK","ALJ[LN","Em}",
        "Label7/Label8/Label9");
 
		//24
        Ku Nomishirami = new Ku("al","n̔A","","m~V~","E}mVgX","}Ng",
        "Label7/Label8/Label9");

		public Ku Kanjihiragana;
 		public Ku KknWorking = new Ku("");

		public void KuSetting(int i)
		{
			switch (i)
			{
				case 1:	Kanjihiragana = Natsukusaya; break;
				case 2: Kanjihiragana = Taichimai; break;
				case 3: Kanjihiragana = Unohanawo; break;
				case 4: Kanjihiragana =  Sanaetoru; break;
				case 5: Kanjihiragana =  Mayuhakiwo; break;
				case 6: Kanjihiragana =  Kisakataya; break;
				case 7: Kanjihiragana = Wasenokaya; break;
				case 8: Kanjihiragana = Monokakite; break;
				case 9: Kanjihiragana = Yomosugara; break;
				case 10:Kanjihiragana = Nomishirami; break;
				default:Kanjihiragana = Natsukusaya; break;
			}

		}//void KuSetting(int i) end
   
		public string KknMyFurigana()
		{
			string stringKami, stringNaka, stringShimo;
			string KknMyAnswer; 

			stringKami = KknWorking.KknKami;
			stringNaka = KknWorking.KknNaka;
			stringShimo = KknWorking.KknShimo;


            KknMyAnswer = stringKami+"    "+stringNaka+"    "+stringShimo;

			return KknMyAnswer;
		}

		public string KknCorrectFurigana()
		{
			string stringKami, stringNaka, stringShimo;
			stringKami = KknWorking.KknKami;
			stringNaka = KknWorking.KknNaka;
			stringShimo = KknWorking.KknShimo;

            string answerKami, answerNaka, answerShimo;
			string KknCorrectAnswer;
			answerKami = Kanjihiragana.KknKami;
			answerNaka = Kanjihiragana.KknNaka;
			answerShimo = Kanjihiragana.KknShimo;
			if (stringKami == " ......................") answerKami = " ......................";
			if (stringNaka == " ............................ ") answerNaka = " ............................";
			if (stringShimo ==  "......................") answerShimo = " ......................";

			KknCorrectAnswer =  answerKami + "    "+ answerNaka + "    " + answerShimo;
			return KknCorrectAnswer;
		}

		public int Score()
		{
			int scorePoints = 0;

			if (KknWorking.KknKami == Kanjihiragana.KknKami)  scorePoints += 33;
			if (KknWorking.KknNaka == Kanjihiragana.KknNaka)  scorePoints += 34;
			if (KknWorking.KknShimo == Kanjihiragana.KknShimo) scorePoints += 33;
			            
			return scorePoints;
		}

		public KuE KamiNakaShimoE(string englishKu)
		{
			int leftPick;
			int rightPick;
			int L;
			string[] q = {"","",""};
			int qIdx;
			KuE Q;

			L = englishKu.Length;
			leftPick = -1;
			rightPick = englishKu.IndexOf("/");
			qIdx = 0;
			while (rightPick != -1)
			{
                q[qIdx] = englishKu.Substring(leftPick+1, rightPick-leftPick-1);
				leftPick = rightPick;
				rightPick = englishKu.IndexOf("/",leftPick+1);
				++qIdx;
			}
			q[2] = englishKu.Substring(leftPick+1, L-leftPick-1);

			Q.kamiE = q[0];
            Q.nakaE = q[1];
			Q.shimoE = q[2];

			return Q;

		}



	}//class KknFuriganaCheck
}
