//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace NatsukusayaSample0
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        

        //ûق@The Narrow Road to Oku / Donald Keenevpage86, 87
        string[] NatsukusayaJ = {"kj.đ","hg.","es.\n",

									"kj.     ","hg.ǂ","es.\n",

									"kj.           ","hg.","kj.","es.\n",

									"dt.                .....","nJ.m", 
                                    "es.\n\n"};
                                    //"es.\n", "kj.  ", "es.\n"};


        string[] NatsukusayaE = {"da.The", "nn. summer", "nn. grasses",
									"pm. -", "es.\n",

									"pp.     Of","aj. brave",
									"nn. solidiers'","nn. dreams","es.\n",

									"da.          The","nn. aftermath",
									"pm..","es.\n",

									"dt.        ...",
									"vb. Translated",
									"pp. by", "nE. Donald Keene", "es.\n",

									"nn.  ", "es.\n"};

        private void button1_Click(object sender, EventArgs e)
        {
            int arrayL, phraseL;
            string partOfSpeech; //part of speech, i
            string phrase;

            int iLeft = 0;

            richTextBox1.Clear();

            arrayL = NatsukusayaJ.Length;

            for (int i = 0; i < arrayL; i++)
            {
                phraseL = NatsukusayaJ[i].Length;
                partOfSpeech = NatsukusayaJ[i].Substring(0, 2);
                phrase = NatsukusayaJ[i].Substring(3, phraseL - 3);

                richTextBox1.AppendText(phrase);
                richTextBox1.Select(iLeft, phrase.Length);
                iLeft += phrase.Length;
                switch (partOfSpeech)
                {
                    case "es": richTextBox1.SelectionColor = Color.Black; break;
                    case "kj": richTextBox1.SelectionColor = Color.Blue; break;
                    case "hg": richTextBox1.SelectionColor = Color.Brown; break;
                    case "kk": richTextBox1.SelectionColor = Color.Gray; break;
                    case "nJ": richTextBox1.SelectionColor = Color.Purple; break;
                    case "dt": richTextBox1.SelectionColor = Color.Black; break;
                    default: richTextBox1.SelectionColor = Color.Empty; break;

                }

            }

            arrayL = NatsukusayaE.Length;
            for (int i = 0; i < arrayL; i++)
            {

                phraseL = NatsukusayaE[i].Length;
                partOfSpeech = NatsukusayaE[i].Substring(0, 2);
                phrase = NatsukusayaE[i].Substring(3, phraseL - 3);

                richTextBox1.AppendText(phrase);
                richTextBox1.Select(iLeft, phrase.Length);
                iLeft += phrase.Length;
                switch (partOfSpeech)
                {
                    case "da": richTextBox1.SelectionColor = Color.Brown; break;
                    case "nn": richTextBox1.SelectionColor = Color.Navy; break;
                    case "pm": richTextBox1.SelectionColor = Color.Violet; break;
                    case "es": richTextBox1.SelectionColor = Color.Gray; break;
                    case "pp": richTextBox1.SelectionColor = Color.Purple; break;
                    case "dt": richTextBox1.SelectionColor = Color.Black; break;
                    case "vb": richTextBox1.SelectionColor = Color.Aqua; break;
                    default: richTextBox1.SelectionColor = Color.Blue; break;
                }
            }


        }

        private void richTextBox1_MouseDown(object sender, MouseEventArgs e)
        {
            richTextBox1.Text = "";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int arrayL, phraseL;
            string partOfSpeech; //part of speech, i
            string phrase;

            int iLeft = 0;

            richTextBox1.Clear();

            arrayL = NatsukusayaJ.Length;

            for (int i = 0; i < arrayL; i++)
            {
                phraseL = NatsukusayaJ[i].Length;
                partOfSpeech = NatsukusayaJ[i].Substring(0, 2);
                phrase = NatsukusayaJ[i].Substring(3, phraseL - 3);

                richTextBox1.AppendText(phrase);
                richTextBox1.Select(iLeft, phrase.Length);
                iLeft += phrase.Length;
                switch (partOfSpeech)
                {
                    case "es": richTextBox1.SelectionColor = Color.Black; break;
                    case "kj": richTextBox1.SelectionColor = Color.Red; break;
                    case "hg": richTextBox1.SelectionColor = Color.Green; break;
                    case "kk": richTextBox1.SelectionColor = Color.Gray; break;
                    case "nJ": richTextBox1.SelectionColor = Color.Navy; break;
                    case "dt": richTextBox1.SelectionColor = Color.Black; break;
                    default: richTextBox1.SelectionColor = Color.Empty; break;

                }

            }

            arrayL = NatsukusayaE.Length;
            for (int i = 0; i < arrayL; i++)
            {

                phraseL = NatsukusayaE[i].Length;
                partOfSpeech = NatsukusayaE[i].Substring(0, 2);
                phrase = NatsukusayaE[i].Substring(3, phraseL - 3);

                richTextBox1.AppendText(phrase);
                richTextBox1.Select(iLeft, phrase.Length);
                iLeft += phrase.Length;
                switch (partOfSpeech)
                {

                    case "da": richTextBox1.SelectionColor = Color.Red; break;
                    case "nn": richTextBox1.SelectionColor = Color.Blue; break;
                    case "pm": richTextBox1.SelectionColor = Color.Brown; break;
                    case "es": richTextBox1.SelectionColor = Color.Gray; break;
                    case "pp": richTextBox1.SelectionColor = Color.Aqua; break;
                    case "dt": richTextBox1.SelectionColor = Color.Black; break;
                    case "vb": richTextBox1.SelectionColor = Color.Purple; break;
                    default: richTextBox1.SelectionColor = Color.Green; break;

                }
            }
        }



    }
}