//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;

	/*oƂ̉p󎍂
	  Donald Keene ûق@The Narrow Road To Okuv
@@      ukЃC^[iVii2003N74@9j
	  p*/

namespace NatsukusayaSample1
{
	/// <summary>
	/// HaikuBook ̊Tv̐łB
	/// </summary>
	public class HaikuBook
	{
		public HaikuBook()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		//ûق@The Narrow Road to Oku / Donald Keenevpage86, 87
		string[] NatsukusayaJ = {"kj.đ","hg.","es.\n",

									"kj.     ","hg.ǂ","es.\n",

									"kj.           ","hg.","kj.","es.\n",

									"dt.                .....","nJ.m", "es.\n",

									"kj.  ", "es.\n"};
		                        

		string[] NatsukusayaE = {"da.The", "aj. summer", "nn. grasses",
									"pm.-", "es.\n",

									"pp.     Of","aj. brave",
									"nn. solidiers'","nn. dreams","es.\n",

									"da.          The","nn. aftermath",
									"pm..","es.\n",

									"dt.        ...",
									"vb. Translated",
									"pp. by", "nE. Donald Keene", "es.\n",

									"nn.  ", "es.\n"};

		internal void WriteAllJ(PhraseWritersWorkshop1 pwwX)
		{
			int i, arrayL, phraseL;
			string partOfSpeech; //part of speech, i
			string phrase; 

			arrayL = NatsukusayaJ.Length; 

			for (i=0; i<arrayL; i++)
			{
				phraseL = NatsukusayaJ[i].Length;
				partOfSpeech = NatsukusayaJ[i].Substring(0,2);
				phrase = NatsukusayaJ[i].Substring(3,phraseL-3);
				switch (partOfSpeech)
				{
					case "es": pwwX.WriteEscapeSequenceJ(phrase); break;
					case "kj": pwwX.WriteKanjiJ(phrase); break;
					case "hg": pwwX.WriteHiraganaJ(phrase); break;
					case "kk": pwwX.WriteKatakanaJ(phrase); break;
					case "nJ": pwwX.WriteNameJ(phrase); break;
					case "dt": pwwX.WriteDotsJ(phrase); break;
					default: pwwX.WriteNothingJ();break;
								
				}
				
			}
		}

		
		internal void WriteAllE(PhraseWritersWorkshop1 pwwX)
		{
			int i, arrayL, phraseL;
			string partOfSpeech; //part of speech
			string phrase; 

			arrayL = NatsukusayaE.Length;

			for (i=0; i<arrayL; i++)
			{
				phraseL = NatsukusayaE[i].Length;
				partOfSpeech = NatsukusayaE[i].Substring(0,2);
				phrase = NatsukusayaE[i].Substring(3,phraseL-3);
				switch (partOfSpeech)
				{
					case "aj": pwwX.WriteAdjectiveE(phrase); break;
					case "av": pwwX.WriteAdverbE(phrase); break;
					case "cj": pwwX.WriteConjunctionE(phrase); break;
					case "da": pwwX.WriteDefArticleE(phrase); break;
					case "ia": pwwX.WriteInfArticleE(phrase); break;
					case "nE": pwwX.WriteNameE(phrase); break;
					case "nn": pwwX.WriteNounE(phrase); break;
					case "pm": pwwX.WritePunctuationMarksE(phrase); break;
					case "pn": pwwX.WritePronounE(phrase); break;
					case "pN": pwwX.WriteProperNounE(phrase); break;
					case "pp": pwwX.WritePrepositionE(phrase); break;
					case "vb": pwwX.WriteVerbE(phrase); break;
					case "dt": pwwX.WriteDotsE(phrase); break;
					case "es": pwwX.WriteEscapeSequenceE(phrase); break;
					default: pwwX.WriteNothingE();break;
								
				}
				
			}
		}

        






	}




}
