//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Drawing;
using System.Windows.Forms;

	/*oƂ̉p󎍂
	  Donald Keene ûق@The Narrow Road To Okuv
@@      ukЃC^[iVii2003N74@9j
	  p*/

namespace NatsukusayaSample2
{
	/// <summary>
	/// HaikuBookTest2 ̊Tv̐łB
	/// </summary>
	public class HaikuBookTest2
	{

		//ûق@The Narrow Road to Oku / Donald Keenevpage 100
		string[] SamidarewoJ = {"Blu.܌J","Mag.","Bla.\n",
									"Sal.     ","Mar.", "Bro.", "Sie.", "Gre.", "Blu.", "Bla.\n",
									"Pur.             ŏ","Bla.\n",
									"Gra.                  ...","Tom.m", "Bla.\n\n", 
									};   
		                        

		string[] SamidarewoE = {"Bro.Gathering", "Tan. seawards", "Bla.\n",
									"Gre.     The","Cya. summer",
									"Vio. rains,","Red. how", "Tom. swift", 
                                    "Pin. it", "Gol. is", "Bro.!","Bla.\n",
									"Mar.          Mogami","Nav. River",
									"Lim..","Bla.\n",
									"Blu.        ...",
									"Pur. Translated",
									"Sie. by", "Gra. Donald Keene", "Bla.\n\n",
									"Ora."};

		IPhraseByColor[]  phraseArrayJ; 
		IPhraseByColor[]  phraseArrayE;

		public HaikuBookTest2()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//

			int arrayL;
			arrayL = SamidarewoJ.Length;

            phraseArrayJ = new IPhraseByColor[arrayL]; 

			for (int i=0; i<=arrayL-1; i++)
			{  
				phraseArrayJ[i] = new HaikuPhrase(SamidarewoJ[i]);
			}

			arrayL = SamidarewoE.Length;
			phraseArrayE = new IPhraseByColor[arrayL];

			for (int i=0; i<=arrayL-1; i++)
			{
				phraseArrayE[i] = new HaikuPhrase(SamidarewoE[i]);
			}

		}//RXgN^end

		internal void WriteAllJ(IDisplayWorkshop workshop) 
		{
			foreach (IPhraseByColor  arrayElement in phraseArrayJ)
			{
				arrayElement.WriteHaikuPhrase(workshop);
			}
		}

		internal void WriteAllE(IDisplayWorkshop workshop) 
		{
			foreach (IPhraseByColor  arrayElement in phraseArrayE)
			{
				arrayElement.WriteHaikuPhrase(workshop);
			}
		}




	}//public class HaikuBookTest2



	abstract class PhraseAnalyzer
	{
		private string actualPhrase;
		private string colorSelection;
		private Color color;


		private int phraseL;

		public PhraseAnalyzer(string dummyPhrase)
		{
			this.phraseL = dummyPhrase.Length;
			this.colorSelection = dummyPhrase.Substring(0, 3);
			this.actualPhrase = dummyPhrase.Substring(4, phraseL-4);
		}
	    protected string GetPhrase()
		{
			return this.actualPhrase;
		}
		protected Color GetColor()
		{
			switch (this.colorSelection)
			{
				case "Red": color = Color.Red; break;
				case "Tom": color = Color.Tomato; break;
				case "Cri": color = Color.Crimson; break;
				case "Mag": color = Color.Magenta; break;
				case "Pin": color = Color.Pink; break;
				case "Ora": color = Color.Orange; break;
				case "Sal": color = Color.Salmon; break;
				case "Whe": color = Color.Wheat; break;
				case "Gol": color = Color.Gold; break;
				case "Yel": color = Color.Yellow; break;
				case "Mar": color = Color.Maroon; break;
				case "Bro": color = Color.Brown; break;
				case "Sie": color = Color.Sienna; break;
				case "Tan": color = Color.Tan; break;
				case "Oli": color = Color.Olive; break;
				case "Gre": color = Color.Green; break;
				case "Lim": color = Color.Lime; break;
				case "Nav": color = Color.Navy; break;
				case "Blu": color = Color.Blue; break;
				case "Cya": color = Color.Cyan; break;
				case "Pur": color = Color.Purple; break;
				case "Vio": color = Color.Violet; break;
				case "Bla": color = Color.Black; break;
				case "Gra": color = Color.Gray; break;
				case "Sil": color = Color.Silver; break;
				default: color = Color.Red; break; 
			}// switch(this.colorSelection) Color list  
            

            
			return this.color;
		}
	}//abstract class PhraseAnalyzer

	
	//z̗vfƐFLɕāA\\bhŕ\B
	class HaikuPhrase:PhraseAnalyzer, IPhraseByColor
	{
		public HaikuPhrase(string dummyPhrase):base(dummyPhrase){}
		void IPhraseByColor.WriteHaikuPhrase(IDisplayWorkshop workshop)
		{
			workshop.WriteByColor(GetPhrase(), GetColor());
		}

	}

	//w肳ꂽFŃb`eLXg{bNXɕ\ƂsB
	class PhraseWriteByColorWorkshop:IDisplayWorkshop
	{
		private RichTextBox richtextbox;
		private int leftOfPhrase;

		public PhraseWriteByColorWorkshop(RichTextBox RTB)
		{
			richtextbox = RTB;
			richtextbox.Clear();
			leftOfPhrase = 0;
		}
		
		void IDisplayWorkshop.WriteByColor(string phrase, Color color)
		{
			richtextbox.AppendText(phrase);
			richtextbox.Select(leftOfPhrase, phrase.Length);
			leftOfPhrase += phrase.Length;
			richtextbox.SelectionColor = color;
		}

	}


	interface IDisplayWorkshop
	{
		void WriteByColor(string phrase, Color color);
	}

@@//HaikuPhrasẽCX^Xǒ̐ł邪A
	//̎̂̓\bhWriteHaikuPhrasełB̃b\bh
	//̏WcƂ܂Ƃ߂B
	interface IPhraseByColor
	{
		void WriteHaikuPhrase(IDisplayWorkshop workshop);
	}

	


}//namespace 
