//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Drawing;
using System.Windows.Forms;

	/*oƂ̉p󎍂
	  Donald Keene ûق@The Narrow Road To Okuv
@@      ukЃC^[iVii2003N74@9j
	  p*/

namespace NatsukusayaSample2
{
	/// <summary>
	/// HaikuBookTest3 ̊Tv̐łB
	/// </summary>
	

	public class HaikuBookTest3
	{
		private Color PrevColor0;
        public Color PrevColor1;
		public Color PrevColor2;

		//ûق@The Narrow Road to Oku / Donald Keenevpage 100
		string[] SamidarewoJ = {"܌J","","\n",
								   "     ","", "", "", "", "", "\n",
								   "             ŏ","\n",
								   "                  ...","m", 
                                   "\n\n", 
		                           };   
		                        

		string[] SamidarewoE = {"Gathering", " seawards", "\n",
								   "     The"," summer",
								   " rains,"," how", " swift", 
								   " it", " is", "!","\n",
								   "          Mogami"," River",
								   ".","\n",
								   "        ...",
								   " Translated",
								   " by", " Donald Keene", 
@@@@@@@@@@@@@@@@@@"\n\n",
								   };

		IPhraseByColor3[]  phraseArrayJ; 
		IPhraseByColor3[]  phraseArrayE;

		public HaikuBookTest3()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//

			int arrayL;
			arrayL = SamidarewoJ.Length;

			phraseArrayJ = new IPhraseByColor3[arrayL]; 

			int[] m = new int[25];
			Random random = new Random();	

			for (int i=0; i<=24; i++) { m[i] = i+1; }
			for (int i=24; i>=1; i--)
			{
				int t;
				int n;
				n = random.Next(0,i);
				t = m[i];
				m[i] = m[n];
				m[n] = t;
			}
			for (int i=0; i<=arrayL-1; i++)
			{ 
				HaikuPhrase3 hp3;
				phraseArrayJ[i] = hp3 = new HaikuPhrase3(SamidarewoJ[i], m[i]);
				PrevColor0 = hp3.PREVCOLOR();  
			}
			PrevColor1 = PrevColor0;

			arrayL = SamidarewoE.Length;
			phraseArrayE = new IPhraseByColor3[arrayL];
			for (int i=24; i>=1; i--)
			{
				int t;
				int n;
				n = random.Next(0,i);
				t = m[i];
				m[i] = m[n];
				m[n] = t;
			}

			for (int i=0; i<=arrayL-1; i++)
			{
				HaikuPhrase3 hp3;
				phraseArrayE[i] = hp3 = new HaikuPhrase3(SamidarewoE[i], m[i]);
				PrevColor0 = hp3.PREVCOLOR();
			}
			PrevColor2 = PrevColor0;

		}//RXgN^end

		internal void WriteAllJ3(PhraseWriteByColorWorkshop3 workshop3)
		{
			foreach (IPhraseByColor3  arrayElement in phraseArrayJ)
			{
				arrayElement.WriteHaikuPhrase3(workshop3);
			}
		}

		internal void WriteAllE3(PhraseWriteByColorWorkshop3 workshop3)
		{
			foreach (IPhraseByColor3  arrayElement in phraseArrayE)
			{
				arrayElement.WriteHaikuPhrase3(workshop3);
			}
		}




	}//public class HaikuBookTest3



	abstract class PhraseAnalyzer3 //abstractȂĂɎx͂܂B
	{
		private readonly string actualPhrase;
		private readonly int n;
		private Color color;

		public PhraseAnalyzer3(string dummyPhrase, int nDummy)
		{ 
			actualPhrase = dummyPhrase;
			n = nDummy;
		}

		protected string GetPhrase()
		{
			return this.actualPhrase;
		}

		protected Color GetColor()
		{
			switch (n)
			{
				case 1: color = Color.Red; break;
				case 2: color = Color.Tomato; break;
				case 3: color = Color.Crimson; break;
				case 4: color = Color.Magenta; break;
				case 5: color = Color.Pink; break;
				case 6: color = Color.Orange; break;
				case 7: color = Color.Salmon; break;
				case 8: color = Color.Wheat; break;
				case 9: color = Color.Gold; break;
				case 10: color = Color.Yellow; break;
				case 11: color = Color.Maroon; break;
				case 12: color = Color.Brown; break;
				case 13: color = Color.Sienna; break;
				case 14: color = Color.Tan; break;
				case 15: color = Color.Olive; break;
				case 16: color = Color.Green; break;
				case 17: color = Color.Lime; break;
				case 18: color = Color.Navy; break;
				case 19: color = Color.Blue; break;
				case 20: color = Color.Cyan; break;
				case 21: color = Color.Purple; break;
				case 22: color = Color.Violet; break;
				case 23: color = Color.Black; break;
				case 24: color = Color.Gray; break;
				case 25: color = Color.Silver; break;
				default: color = Color.Red; break; 
			}// switch(n) Color list
  
			return this.color;
		}
	}//abstract class PhraseAnalyzer

	
	//z̗vfƃJ[ԍ󂯎āA\B\bhPREVCOLORColorԂB
	class HaikuPhrase3:PhraseAnalyzer3, IPhraseByColor3
	{
		public HaikuPhrase3(string dummyPhrase, int n):base(dummyPhrase, n)
		{
		}
		void IPhraseByColor3.WriteHaikuPhrase3(IDisplayWorkshop3 workshop3)
		{
			workshop3.WriteByColor3(GetPhrase(), GetColor());

			//߂ʂo߂̗VюԂ13~bɐݒ
			DateTime time1, time2;
			TimeSpan timespan;
			time1=DateTime.Now;			
			do 
			{
				time2=DateTime.Now;
				timespan = time2.Subtract(time1);
			}while(timespan.Milliseconds<=13);
			//
		}

		public Color PREVCOLOR()
		{
			return GetColor();
		}
	}

	//\\bh@w肳ꂽFŃb`eLXg{bNXɕ\ƂsB
	class PhraseWriteByColorWorkshop3:IDisplayWorkshop3
	{
		private readonly RichTextBox richtextbox;
		private int leftOfPhrase;

		public PhraseWriteByColorWorkshop3(RichTextBox RTB)
		{
			richtextbox = RTB;
			richtextbox.Clear();
			leftOfPhrase = 0;
		}
		
		void IDisplayWorkshop3.WriteByColor3(string phrase, Color color)
		{
			richtextbox.AppendText(phrase);
			richtextbox.Select(leftOfPhrase, phrase.Length);
			leftOfPhrase += phrase.Length;
			richtextbox.SelectionColor = color;
		}

	}

	interface IDisplayWorkshop3
	{
		void WriteByColor3(string phrase, Color color);
	}

@@//C^[tF[XBHaikuPhrasẽCX^Xǒ̐
	//ł邪A̎̂̓\bhWriteHaikuPhrasełB̃b\bh
	//̏WcƂ܂Ƃ߂B
	interface IPhraseByColor3
	{
		void WriteHaikuPhrase3(IDisplayWorkshop3 workshop3);
	}



}
