//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;

namespace NatsukusayaSample2
{
	
	interface IPhraseWritersGroupJ
	{
		void WriteEscapeSequence(string esq); //es
		void WriteKanji(string kanji);       //kj
		void WriteHiragana(string hiragana); //hg
		void WriteKatakana(string katakana); //kk
		void WriteNameJ(string nameJ);       //nJ
		void WriteDots(string dots);         //..
		void WriteNothing();
	}

	interface IPhraseWritersGroupE
	{
        void WriteEscapeSequence(string esq); //es
		void WriteProperNoun(string ppnn);   //pN
		void WritePreposition(string prep);  //pp
		void WritePronoun(string prnn);      //pn
		void WriteNoun(string noun);         //nn
		void WriteVerb(string verb);         //vb
		void WriteConjunction(string conj);  //cj
		void WriteAdjective(string adj);     //aj
		void WriteAdverb(string adv);        //av
		void WriteNameE(string nameE);       //nE
		void WriteInfArticle(string infa);   //ia
		void WriteDefArticle(string defa);   //da
		void WritePunctuationMarks(string pm);      //pm
		void WriteRelatives(string rl);      //rl
		void WriteDots(string dots);         //..
		void WriteNothing();
	}
}
