//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Drawing;
using System.Windows.Forms;

namespace NatsukusayaSample1
{
	/// <summary>
	/// PhraseWritersWorkshop2 ̊Tv̐łB
	/// </summary>
	public class PhraseWritersWorkshop2
	{

		public PhraseWritersWorkshop2(RichTextBox RTB)
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			richtextbox = RTB;
			richtextbox.Clear();
			iOfPhrase = 0;

		}

		private readonly RichTextBox richtextbox;
		private int iOfPhrase; 

		private void WritePhrase(string phrase, Color color)
		{
			richtextbox.AppendText(phrase);
			richtextbox.Select(iOfPhrase, phrase.Length);
			richtextbox.SelectionColor = color;
			iOfPhrase += phrase.Length;
		}

		// :IPhraseWritersGroupJ begin
		public void   WriteDotsJ(string dots)
		{
			WritePhrase(dots, Color.Purple);
		}
		public void   WriteEscapeSequenceJ(string es)
		{
			WritePhrase(es, Color.Black);
		}
		public void   WriteHiraganaJ(string hiragana)
		{
			WritePhrase(hiragana, Color.Green);
		}
		public void   WriteKanjiJ(string kanji)
		{
			WritePhrase(kanji, Color.Blue);
		}
		public void   WriteKatakanaJ(string katakana)
		{
			WritePhrase(katakana, Color.Black);
		}
		public void   WriteNameJ(string nameJ)
		{
			WritePhrase(nameJ, Color.Brown);
		}
		public void   WriteNothingJ()
		{
			WritePhrase("", Color.Black);
		}
		//:IPhraseWritersGroupJ end

		//:IPhraseWritersGroupE begin
		public void   WriteAdjectiveE(string aj)
		{
			WritePhrase(aj, Color.Red);
		}
		public void   WriteAdverbE(string av)
		{
			WritePhrase(av, Color.Aqua);
		}
		public void   WriteConjunctionE(string cj)
		{
			WritePhrase(cj, Color.Black);
		}
		public void   WriteDefArticleE(string da)
		{
			WritePhrase(da, Color.Aquamarine);
		}
		public void   WriteDotsE(string dots)
		{
			WritePhrase(dots, Color.Blue);
		}
		public void   WriteInfArticleE(string ia)
		{
			WritePhrase(ia, Color.Brown);
		}
		public void   WriteNameE(string nE)
		{
			WritePhrase(nE, Color.Maroon);
		}
		public void   WriteNothingE()
		{
			WritePhrase("" , Color.DarkMagenta);
		}
		public void   WriteNounE(string nn )
		{
			WritePhrase(nn , Color.Black);
		}
		public void   WritePunctuationMarksE(string pm )
		{
			WritePhrase(pm , Color.Green);
		}
		public void   WritePronounE(string pn )
		{
			WritePhrase(pn , Color.Gray);
		}
		public void   WriteProperNounE(string pN )
		{
			WritePhrase(pN , Color.Lavender);
		}
		public void   WritePrepositionE(string pp )
		{
			WritePhrase(pp, Color.Magenta);
		}
		public void   WriteRelativesE(string rl)
		{
			WritePhrase(rl, Color.DarkKhaki);
		}
		public void   WriteVerbE(string vb)
		{
			WritePhrase(vb , Color.Navy);
		}
		public void   WriteEscapeSequenceE(string es)
		{
			WritePhrase(es , Color.Black);
		}
		//:IPhraseWritersGroupE end







	}
}
