//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;

	/*oƂ̉p󎍂
	  Donald Keene ûق@The Narrow Road To Okuv
@@      ukЃC^[iVii2003N74@9j
	  p*/

namespace NatsukusayaSample2
{
	/// <summary>
	/// HaikuBook ̊Tv̐łB
	/// </summary>
	public class HaikuBook
	{
		public HaikuBook()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		//ûق@The Narrow Road to Oku / Donald Keenevpage86, 87
		string[] NatsukusayaJ = {"kj.đ","hg.","es.\n",

                             "kj.     ","hg.ǂ","es.\n",

                             "kj.           ","hg.","kj.","es.\n",

		                     "dt.                .....","nJ.m", "es.\n",

		                     "kj.  ", "es.\n"};
		                        

		string[] NatsukusayaE = {"da.The", "nn. summer", "nn. grasses",
							 "pm.-", "es.\n",

                              "pp.     Of","aj. brave",
                              "nn. solidiers'","nn. dreams","es.\n",

                              "da.          The","nn. aftermath",
                              "pm..","es.\n",

		                      "dt.        ...",
							  "vb. Translated",
							  "pp. by", "nE. Donald Keene", "nE.\n\n",
								};

		internal void WriteAllJ(IPhraseWritersGroupJ igJ)
		{
			int i, arrayL, phraseL;
			string partOfSpeech; //part of speech, i
			string phrase; 

			arrayL = NatsukusayaJ.Length; 

			for (i=0; i<arrayL; i++)
			{
				phraseL = NatsukusayaJ[i].Length;
				partOfSpeech = NatsukusayaJ[i].Substring(0,2);
				phrase = NatsukusayaJ[i].Substring(3,phraseL-3);
				switch (partOfSpeech)
				{
					case "es": igJ.WriteEscapeSequence(phrase); break;
					case "kj": igJ.WriteKanji(phrase); break;
					case "hg": igJ.WriteHiragana(phrase); break;
					case "kk": igJ.WriteKatakana(phrase); break;
					case "nJ": igJ.WriteNameJ(phrase); break;
					case "dt": igJ.WriteDots(phrase); break;
					default: igJ.WriteNothing();break;
								
				}
				
			}
		}

		
		internal void WriteAllE(IPhraseWritersGroupE igE)
		{
			int i, arrayL, phraseL;
			string partOfSpeech; //part of speech
			string phrase; 

			arrayL = NatsukusayaE.Length;

			for (i=0; i<arrayL; i++)
			{
				phraseL = NatsukusayaE[i].Length;
				partOfSpeech = NatsukusayaE[i].Substring(0,2);
				phrase = NatsukusayaE[i].Substring(3,phraseL-3);
				switch (partOfSpeech)
				{
					case "aj": igE.WriteAdjective(phrase); break;
					case "av": igE.WriteAdverb(phrase); break;
					case "cj": igE.WriteConjunction(phrase); break;
					case "da": igE.WriteDefArticle(phrase); break;
					case "ia": igE.WriteInfArticle(phrase); break;
					case "nE": igE.WriteNameE(phrase); break;
					case "nn": igE.WriteNoun(phrase); break;
					case "pm": igE.WritePunctuationMarks(phrase); break;
					case "pn": igE.WritePronoun(phrase); break;
					case "pN": igE.WriteProperNoun(phrase); break;
					case "pp": igE.WritePreposition(phrase); break;
					case "vb": igE.WriteVerb(phrase); break;
					case "dt": igE.WriteDots(phrase); break;
					case "es": igE.WriteEscapeSequence(phrase); break;
					default: igE.WriteNothing();break;
								
				}
				
			}
		}

        



	}
}
