//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace OkuNoHosomichiX
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        HAIKU[] E = new HAIKU[63];
        int iE = 0;
        int seikaiI;

        private void Form1_Load(object sender, EventArgs e)
        {
            richTextBox1.Clear();
            richTextBox2.Clear();
            textBox1.Text = "";
            textBox2.Text = "";

            textBox1.Focus();

            label2.ForeColor = Color.Brown;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            richTextBox1.Clear();
            richTextBox2.Clear();

            textBox2.Text = "";

            radioButton1.Checked = false;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton9.Checked = false;
            radioButton10.Checked = false;

            textBox1.Focus();

            Ohhc1 c1 = new Ohhc1();
            c1.HaikuDome();
            HAIKU kotaeE;

            for (int i = 0; i < 63; i++)
            {
                E[i] = c1.B[i];
            }


            try
            {
                iE = Convert.ToInt16(textBox1.Text);
                if (!((iE == 21) || (iE == 29) || (iE == 30))) throw new System.Exception();
                //if ((iE<1)||(iE>63)) throw new System.Exception();
            }
            catch
            {
                MessageBox.Show("̔ԍ͌ݎgpĂ܂B");
                goto Exit;
            }

            --iE;

            kotaeE = E[iE];

            Rtbx1HaikuE(kotaeE);

            PrepareRtbx2(kotaeE);

        Exit: iE += 0; 
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int i = 0;
            string s = "s!";

            if (radioButton1.Checked) i = 1;
            if (radioButton2.Checked) i = 2;
            if (radioButton3.Checked) i = 3;
            if (radioButton4.Checked) i = 4;
            if (radioButton5.Checked) i = 5;
            if (radioButton6.Checked) i = 6;
            if (radioButton7.Checked) i = 7;
            if (radioButton8.Checked) i = 8;
            if (radioButton9.Checked) i = 9;
            if (radioButton10.Checked) i = 10;


            if ((seikaiI == 1) && (radioButton1.Checked)) s = "!";
            if ((seikaiI == 2) && (radioButton2.Checked)) s = "!";
            if ((seikaiI == 3) && (radioButton3.Checked)) s = "!";
            if ((seikaiI == 4) && (radioButton4.Checked)) s = "!";
            if ((seikaiI == 5) && (radioButton5.Checked)) s = "!";
            if ((seikaiI == 6) && (radioButton6.Checked)) s = "!";
            if ((seikaiI == 7) && (radioButton7.Checked)) s = "!";
            if ((seikaiI == 8) && (radioButton8.Checked)) s = "!";
            if ((seikaiI == 9) && (radioButton9.Checked)) s = "!";
            if ((seikaiI == 10) && (radioButton10.Checked)) s = "!";

            if (s == "!") textBox2.ForeColor = Color.Red;
            if (s == "s!") textBox2.ForeColor = Color.Navy;
            textBox2.Text = i.ToString() + " " + s;
            if (i == 0)
            {
                textBox2.ForeColor = Color.Green;
                textBox2.Text = "𓚁I";
            }

            radioButton1.Checked = false;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton9.Checked = false;
            radioButton10.Checked = false;

        }

        private void richTextBox1_MouseDown(object sender, MouseEventArgs e)
        {
            richTextBox1.Clear();
            richTextBox2.Clear();

            textBox2.Text = "";

            radioButton1.Checked = false;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton9.Checked = false;
            radioButton10.Checked = false;

            textBox1.Focus();

            //textBox1.Visible = false;
        }

        private void richTextBox2_MouseDown(object sender, MouseEventArgs e)
        {
            /*
            richTextBox1.Clear();
            richTextBox2.Clear();

            textBox2.Text = "";

            radioButton1.Checked = false;
            radioButton2.Checked = false;
            radioButton3.Checked = false;
            radioButton4.Checked = false;
            radioButton5.Checked = false;
            radioButton6.Checked = false;
            radioButton7.Checked = false;
            radioButton8.Checked = false;
            radioButton9.Checked = false;
            radioButton10.Checked = false;
            */
        }

        private void textBox1_MouseDown(object sender, MouseEventArgs e)
        {
            textBox1.Clear();
        }

        //HaikuBookTest3gpāAKu󂯎richTextBox1ɉp󎍂\B
        void Rtbx1HaikuE(HAIKU Ku)
        {
            //richTextBox1.ForeColor = Color.Navy;
            //richTextBox1.AppendText(Ku.KamiNakaShimoE + "\r\n");

            PhraseWriteByColorWorkshop3 w3 = new PhraseWriteByColorWorkshop3(richTextBox1);
            HaikuBookTest3 test3 = new HaikuBookTest3(Ku);

            test3.WriteAllE3(w3);
        }

        //richTextBox2ɁA\Ku󂯎Ĕo\B
        void Rtbx2HaikuJ(HAIKU Ku)
        {
            richTextBox2.AppendText(Ku.KamiNakaShimoKu + "\r\n");
        }

        //richTextBox2ɔo10ׂƁBKu͐\́B
        void PrepareRtbx2(HAIKU seikaiKu)
        {
            int[] haikuList = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            int j = 0, haikuK = 0, seikaiSeat = 0;
            Random random = new Random();

            int[] seat = new int[63];
            for (int i = 0; i <= 62; i++) { seat[i] = i; }
            for (int i = 62; i > 0; i--)
            {
                j = random.Next(0, i);
                haikuK = seat[i];
                seat[i] = seat[j];
                seat[j] = haikuK;
            }

            //seat[0]seat[9]܂ł̂Ȃ
            //܂ܐ̔oKu̔ԍƓ̔oԍseat[62]
            //Ă鐮lƓւBŐƂ̏dB
            for (int i = 0; i < 10; i++)
            {
                int t = 0;
                int ii = 0;
                ii = seat[i];
                if (E[ii].KamiNakaShimoKu == seikaiKu.KamiNakaShimoKu)
                {
                    t = seat[i];
                    seat[i] = seat[62];
                    seat[62] = t;
                }
            }


            /* 0-62mFpfor[vB
                       for (int i=0; i<=62; i++) 
                        {
                             richTextBox1.Text += seat[i].ToString()+"  \r\n";
                        }
            */

            //o̕\ʒu𗐐őI
            seikaiSeat = random.Next(0, 10);
            
            for (int i = 0; i < seikaiSeat; i++)
            {
                int ii;
                ii = seat[i];

                richTextBox2.ForeColor = Color.Brown;
                richTextBox2.Text += (i + 1).ToString() + " ";
                Rtbx2HaikuJ(E[ii]);
                richTextBox2.Text += "\r\n";
            }

            seikaiI = seikaiSeat + 1;
            richTextBox2.Text += seikaiI.ToString() + " ";
            Rtbx2HaikuJ(seikaiKu);
            richTextBox2.Text += "\r\n";

            for (int i = seikaiSeat + 1; i < 10; i++)
            {
                int ii;
                ii = seat[i];
                richTextBox2.Text += (i + 1).ToString() + " ";
                Rtbx2HaikuJ(E[ii]);
                richTextBox2.Text += "\r\n";
            }

            //Rtbx2HaikuJ(Ku);
            //seikaiI = 4;
        }//PrepareRtbx2

    }

}